searchNodes=[{"doc":"A SpatialMap is meant to hold static features in a spatial plane and allow for searching for features by geospatial lookup.","ref":"SpatialMap.html","title":"SpatialMap","type":"module"},{"doc":"Returns the number of features in the SpacialMap Examples iex&gt; SpatialMap . new ( ) ...&gt; |&gt; SpatialMap . count_features ( ) 0 iex&gt; SpatialMap . new ( ) ...&gt; |&gt; SpatialMap . put_feature! ( % Geo.Point { coordinates : { 1 , 3 } } , %{ name : :a } ) ...&gt; |&gt; SpatialMap . put_feature! ( % Geo.Point { coordinates : { 2 , 1 } } , %{ name : :b } ) ...&gt; |&gt; SpatialMap . put_feature! ( % Geo.Point { coordinates : { 4 , 3 } } , %{ name : :c } ) ...&gt; |&gt; SpatialMap . count_features ( ) 3 iex&gt; SpatialMap . new ( storage_type : :ets ) ...&gt; |&gt; SpatialMap . count_features ( ) 0 iex&gt; SpatialMap . new ( storage_type : :ets ) ...&gt; |&gt; SpatialMap . put_feature! ( % Geo.Point { coordinates : { 1 , 3 } } , %{ name : :a } ) ...&gt; |&gt; SpatialMap . put_feature! ( % Geo.Point { coordinates : { 2 , 1 } } , %{ name : :b } ) ...&gt; |&gt; SpatialMap . put_feature! ( % Geo.Point { coordinates : { 4 , 3 } } , %{ name : :c } ) ...&gt; |&gt; SpatialMap . count_features ( ) 3","ref":"SpatialMap.html#count_features/1","title":"SpatialMap.count_features/1","type":"function"},{"doc":"Deltes a feature from the SpatialMap. Imprtant Note : this function also operates on all the cells occupied by the features, so it is as expensive as adding a new feature. Example iex&gt; { map , ref } = ... &gt; SpatialMap . new ( ) ...&gt; |&gt; SpatialMap . put_feature ( % Geo.Point { coordinates : { - 90 , 30 } } , %{ foo : :bar } ) ...&gt; map ...&gt; |&gt; SpatialMap . delete_feature ( ref ) ...&gt; |&gt; SpatialMap . query ( { - 90 , 30 } ) [ ]","ref":"SpatialMap.html#delete_feature/2","title":"SpatialMap.delete_feature/2","type":"function"},{"doc":"Returns the feature from the SpatialMap for the given refence or nil if one is not found. Example iex&gt; { map , ref } = ... &gt; SpatialMap . new ( ) ...&gt; |&gt; SpatialMap . put_feature ( % Geo.Point { coordinates : { - 90 , 30 } } , %{ foo : :bar } ) ...&gt; SpatialMap . get_feature ( map , ref ) |&gt; Map . get ( :properties ) %{ foo : :bar } iex&gt; SpatialMap . new ( ) ...&gt; |&gt; SpatialMap . get_feature ( make_ref ( ) ) nil iex&gt; { map , ref } = ... &gt; SpatialMap . new ( storage_type : :ets ) ...&gt; |&gt; SpatialMap . put_feature ( % Geo.Point { coordinates : { - 90 , 30 } } , %{ foo : :bar } ) ...&gt; SpatialMap . get_feature ( map , ref ) |&gt; Map . get ( :properties ) %{ foo : :bar } iex&gt; SpatialMap . new ( storage_type : :ets ) ...&gt; |&gt; SpatialMap . get_feature ( make_ref ( ) ) nil","ref":"SpatialMap.html#get_feature/2","title":"SpatialMap.get_feature/2","type":"function"},{"doc":"Returns all features in the SpatialMap","ref":"SpatialMap.html#list_features/1","title":"SpatialMap.list_features/1","type":"function"},{"doc":"Moves a feature from one geometry to another. Important Note : This is an even more expensive operation than put_feature in that it has to iterate over the geometry of the orignal position and the new geometry. Example iex&gt; { map , ref } = ... &gt; SpatialMap . new ( ) ...&gt; |&gt; SpatialMap . put_feature ( % Geo.Point { coordinates : { - 90 , 30 } } , %{ foo : :bar } ) ...&gt; map ...&gt; |&gt; SpatialMap . move_feature ( ref , % Geo.Point { coordinates : { - 110 , 40 } } ) ...&gt; |&gt; SpatialMap . query ( { - 90 , 30 } ) [ ] iex&gt; { map , ref } = ... &gt; SpatialMap . new ( storaget_type : :ets ) ...&gt; |&gt; SpatialMap . put_feature ( % Geo.Point { coordinates : { - 90 , 30 } } , %{ foo : :bar } ) ...&gt; map ...&gt; |&gt; SpatialMap . move_feature ( ref , % Geo.Point { coordinates : { - 110 , 40 } } ) ...&gt; |&gt; SpatialMap . query ( { - 90 , 30 } ) [ ]","ref":"SpatialMap.html#move_feature/3","title":"SpatialMap.move_feature/3","type":"function"},{"doc":"Creates a new SpatialMap with the given options. storage_type - can be either :local (default) or :ets . A :local storage type stores the features in a local map inside the SpatialHash struct. An :ets storage type creates wan ETS table for feature storage. Default: :local table_name - an atom specifying the name of the underlying ETS table. This is only used when storage_type is set to :ets and is required if more than one SpatialMap of type :ets is created on the current node. access - when creating a SpatialMap of type :ets , this specifies the access protection for the underlying table. Default: :public grid - specifies the grid to be used with the underlying SpatialHash of the map. Please see SpacialHash documentation for more information. Default: SpatialHash.world_grid() Examples iex&gt; SpatialMap . new ( ) ...&gt; |&gt; SpatialMap . storage_type ( ) :local","ref":"SpatialMap.html#new/1","title":"SpatialMap.new/1","type":"function"},{"doc":"Adds a new feature, which consists of a geometry and a set of metadata, and returns a reference for the feature the updated map. Important Note : For larger features and small grid cell sizes, this function can take an extremely long time. See README.md for more information about this tradoff. Example iex&gt; { map , ref } = ... &gt; SpatialMap . new ( ) ...&gt; |&gt; SpatialMap . put_feature ( % Geo.Point { coordinates : { - 90 , 30 } } , %{ foo : :bar } ) ...&gt; SpatialMap . get_feature ( map , ref ) |&gt; Map . get ( :properties ) %{ foo : :bar }","ref":"SpatialMap.html#put_feature/3","title":"SpatialMap.put_feature/3","type":"function"},{"doc":"Adds a feature to a map and only returns the SpatialMap. This is useful for chaining mulitple features Example iex&gt; SpatialMap . new ( ) ...&gt; |&gt; SpatialMap . put_feature! ( % Geo.Point { coordinates : { - 90 , 30 } } , %{ foo : :bar } ) ...&gt; |&gt; SpatialMap . query ( { - 90 , 30 } ) ... &gt; |&gt; List . first ( ) ...&gt; |&gt; Map . get ( :properties ) %{ foo : :bar }","ref":"SpatialMap.html#put_feature!/3","title":"SpatialMap.put_feature!/3","type":"function"},{"doc":"Queries the SpatialMap for all featurs that intersect the given geometry.","ref":"SpatialMap.html#query/2","title":"SpatialMap.query/2","type":"function"},{"doc":"Same as query/2 , but returns the properties from the resulting features. Examples iex&gt; SpatialMap . new ( ) ...&gt; |&gt; SpatialMap . put_feature! ( % Geo.Point { coordinates : { 1 , 3 } } , %{ name : :a } ) ...&gt; |&gt; SpatialMap . put_feature! ( % Geo.Point { coordinates : { 2 , 1 } } , %{ name : :b } ) ...&gt; |&gt; SpatialMap . put_feature! ( % Geo.Point { coordinates : { 4 , 3 } } , %{ name : :c } ) ...&gt; |&gt; SpatialMap . query_properties ( % Geo.Polygon { coordinates : [ [ { 0 , 0 } , { 0 , 5 } , { 5 , 0 } , { 0 , 0 } ] ] } ) [ %{ name : :a } , %{ name : :b } ]","ref":"SpatialMap.html#query_properties/2","title":"SpatialMap.query_properties/2","type":"function"},{"doc":"Same as query_properties/2 , but returns the value of the given key for the resulting features. Examplesref iex&gt; SpatialMap . new ( ) ...&gt; |&gt; SpatialMap . put_feature! ( % Geo.Point { coordinates : { 1 , 3 } } , %{ name : :a } ) ...&gt; |&gt; SpatialMap . put_feature! ( % Geo.Point { coordinates : { 2 , 1 } } , %{ name : :b } ) ...&gt; |&gt; SpatialMap . put_feature! ( % Geo.Point { coordinates : { 4 , 3 } } , %{ name : :c } ) ...&gt; |&gt; SpatialMap . query_properties ( % Geo.Polygon { coordinates : [ [ { 0 , 0 } , { 0 , 5 } , { 5 , 0 } , { 0 , 0 } ] ] } , :name ) [ :a , :b ]","ref":"SpatialMap.html#query_properties/3","title":"SpatialMap.query_properties/3","type":"function"},{"doc":"Returns the type of storage for the given SpatialMap . Exmaples iex&gt; SpatialMap . new ( storage_type : :ets ) ...&gt; |&gt; SpatialMap . storage_type ( ) :ets","ref":"SpatialMap.html#storage_type/1","title":"SpatialMap.storage_type/1","type":"function"},{"doc":"","ref":"SpatialMap.html#t:geometry/0","title":"SpatialMap.geometry/0","type":"type"},{"doc":"","ref":"SpatialMap.html#t:t/0","title":"SpatialMap.t/0","type":"type"},{"doc":"","ref":"SpatialMap.Feature.html","title":"SpatialMap.Feature","type":"module"},{"doc":"","ref":"SpatialMap.Feature.html#t:t/0","title":"SpatialMap.Feature.t/0","type":"type"}]